package cn.iocoder.yudao.module.pms.service.iotbom;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.collection.CollectionUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotbom.vo.IotBomListReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotbom.vo.IotBomPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotbom.vo.IotBomRespVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotbom.vo.IotBomSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotbom.IotBomDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * PMS BOM 关系 Service 接口
 *
 * @author 芋道源码
 */
public interface IotBomService {

    /**
     * 创建PMS BOM 关系
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createIotBom(@Valid IotBomSaveReqVO createReqVO);

    /**
     * 更新PMS BOM 关系
     *
     * @param updateReqVO 更新信息
     */
    void updateIotBom(@Valid IotBomSaveReqVO updateReqVO);

    /**
     * 更新PMS BOM 关系 只同步没有BOM的设备
     *
     * @param updateReqVO 更新信息
     */
    void updateIotBomAlone(@Valid IotBomSaveReqVO updateReqVO);

    /**
     * 删除PMS BOM 关系
     *
     * @param id 编号
     */
    void deleteIotBom(Long id);

    /**
     * 获得PMS BOM 关系
     *
     * @param id 编号
     * @return PMS BOM 关系
     */
    IotBomDO getIotBom(Long id);

    /**
     * 获得PMS BOM 关系分页
     *
     * @param pageReqVO 分页查询
     * @return PMS BOM 关系分页
     */
    PageResult<IotBomDO> getIotBomPage(IotBomPageReqVO pageReqVO);

    /**
     * 获得PMS BOM树列表
     *
     * @param reqVO 编号
     * @return BOM列表
     */
    List<IotBomDO> getBomList(IotBomListReqVO reqVO);

    /**
     * 获得PMS BOM树列表 分页树根节点
     *
     * @param reqVO 编号
     * @return BOM列表
     */
    PageResult<IotBomRespVO> getBomTreePage(IotBomListReqVO reqVO);

    /**
     * 获得PMS 设备关联-BOM 关系分页
     *
     * @param pageReqVO 分页查询
     * @return PMS 设备关联-BOM 关系分页
     */
    PageResult<IotBomDO> deviceAssociateBomPage(IotBomPageReqVO pageReqVO);

    /**
     * 获得 BOM节点 信息数组
     *
     * @param deviceCategoryIds bom 编号数组
     * @return bom 信息数组
     */
    List<IotBomDO> getBomList(Collection<Long> deviceCategoryIds);

    /**
     * 获得指定编号的 BOM节点 Map
     *
     * @param deviceCategoryIds 设备分类 编号数组
     * @return BOM节点 Map
     */
    default Map<Long, IotBomDO> getBomMap(Collection<Long> deviceCategoryIds) {
        List<IotBomDO> list = getBomList(deviceCategoryIds);
        return CollectionUtils.convertMap(list, IotBomDO::getDeviceCategoryId);
    }

    /**
     * 将设备分类bom拷贝到 设备bom
     *
     * @param deviceCategoryId 设备分类id
     * @param deviceId 设备id
     * @return bom 信息数组
     */
    void copyBomByCategory(Long deviceCategoryId, Long deviceId);

    /**
     * 修改设备分类BOM时将设备分类BOM及BOM节点挂载的物料同步到 设备BOM
     *
     * @param deviceCategoryId 设备分类id
     * @return bom 信息数组
     */
    void syncDeviceBomAndMaterials(Long deviceCategoryId);

    /**
     * 将设备分类A的BOM树 拷贝到 设备分类B的BOM树
     *
     * @param updateReqVO 设备分类A-id  设备分类B-ID
     * @return
     */
    void copyCategoryBom(IotBomSaveReqVO updateReqVO);
}